Subject: IPP Last Call

From: Paul Moore <[email-masked]>
Date: Wed, 11 Feb 1998 14:27:53 -0800

Re: Internet Printing Protocol (IPP) V1  

> I have the following comments on this proposal. You should be aware that I
> was an active participant in this process, attended many of the WG
> meetings and am listed as an author of the current protocol prosposal.
> 
I  beleive that the current protocol is not the best solution and that XML
should be used as the data representation. This is a change from our
original position (that caused  me  to propose the current protocol). The
initial idea was to use ASCII text but in a 'attribute:value' format. It was
agreed that this was not robust enough and that no standard method of
representing structed data in an ASCII stream existed - hence the current
'binary' protocol.

> The reason for proposing this change :-
> 
> a) if XML had been available at the time we would have chosen to use it.
> b) It provides a much less ambigous specification (this leads to better
> interop convergence)
> c) It is generically parsable by any entity that understands XML (useful
> for protcol analysers, proxies, etc.)
> d) It is 'future-proof' in that many of the issues we deferred in IPP1
> will require a rework of the binary protocol. In fact we know of some
> requirements that will not only be impossible to carry using the current
> spec but there are others that will break version 1 parsers. The
> requirements include the ability to pass structured data, arrays of
> structs and nested structures. These are already addressed by XML.
> 
> A full specification of  the  proposed XML mapping for IPP is at
> ftp://ftp.pwg.org/pub/pwg/ipp/new_PRO/draft-xml4ipp.pdf
> 
> 
> Paul Moore 
> Windows NT Program Managment
> Microsoft Corporation
> 425 936 0908

---

From: Keith Moore <[email-masked]>
Date: Wed, 11 Feb 1998 17:59:07 -0500

Paul,

Please provide more detail about a couple of your objections to
IPP's chosen data representation.

> a) if XML had been available at the time we would have chosen to use it.

Okay, but IPP-WG chose not to do so, both "at the time", and again
very recently. 

> b) It provides a much less ambigous specification (this leads to better

Can you point out ambiguities in the existing IPP specification
which would be made less ambiguous by reference to XML?

Keep in mind that there's more than one way to make a specification
ambiguous or difficult to assimilate (the two the same effect
on the quality of products developed from the specification). 

For instance, referencing some other spec might make the IPP less ambiguous, 
but more difficult to assimilate, due to the greater learning curve.

--
Keith Moore <[email-masked]>                 http://www.cs.utk.edu/~moore/
Citizen of cyberspace, currently residing in Knoxville, Tennessee, USA.

---

From: Keith Moore <[email-masked]>
Date: Wed, 11 Feb 1998 17:59:07 -0500

Paul,